#include "ep_lib.hpp"
#include <mpi.h>
#include "ep_declaration.hpp"
#include "ep_mpi.hpp"

namespace ep_lib
{

  int MPI_Finalize()
  {
    printf("calling EP Finalize\n");

    int id = omp_get_thread_num();

    if(id == 0)
    {
      ::MPI_Finalize();
    }
    return 0;
  }

  int MPI_Abort(MPI_Comm comm, int errorcode)
  {
    if(!comm->is_ep)
      return MPI_Abort_mpi(comm, errorcode);

    else
    {
      if(comm->ep_comm_ptr->size_rank_info[1].first == 0)
      {
        ::MPI_Abort(to_mpi_comm(comm->mpi_comm), errorcode);
      }
    }
  }

  int MPI_Abort_mpi(MPI_Comm comm, int errorcode)
  {
    return ::MPI_Abort(to_mpi_comm(comm->mpi_comm), errorcode);
  }

}


